package com.company.sample.controller;

import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/mycontroller")
public class MyController {

    @GetMapping("/hello")
    public ResponseEntity<String> hello(@RequestHeader("X-Custom-Header") String customHeader) {
        if (!isHeaderValid(customHeader)) {
            return ResponseEntity.status(HttpStatus.UNAUTHORIZED).body("Invalid header");
        }
        return ResponseEntity.ok("Hello");
    }

    private boolean isHeaderValid(String header) {
        return "valid".equals(header);
    }
}
